"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.executeShellCommands = void 0;
const childProcess = require("child_process");
const kleur = require("kleur");
const pAll = require("p-all");
async function executeShellCommands(shellCommands, concurrency, debug) {
    if (debug === true) {
        for (const { shellCommand } of shellCommands) {
            console.log(kleur.gray(shellCommand));
        }
    }
    const callbacks = shellCommands.map(function ({ inputFile, outputFile, shellCommand }) {
        return function () {
            return new Promise(function (resolve, reject) {
                childProcess.exec(shellCommand, function (error) {
                    if (error) {
                        reject(error);
                        return;
                    }
                    console.log(`${kleur.green('✔')} ${formatFilePath(inputFile)} ${kleur.gray('›')} ${formatFilePath(outputFile)}`);
                    resolve();
                });
            });
        };
    });
    await pAll(callbacks, { concurrency });
}
exports.executeShellCommands = executeShellCommands;
function formatFilePath(filePath) {
    if (filePath.indexOf(' ') === -1) {
        return filePath;
    }
    return `'${filePath}'`;
}
